 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

 /*
  * $Log$
  */

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "korient.h"
/*-----------------------------------------------------------
| 
|  Routine Name: korient_get_args
| 
|       Purpose: Gets command line args for korient
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname korient
|          Date: Apr 08, 1995
| Modifications: 
| 
------------------------------------------------------------*/
void korient_get_args(
    kform *pane)
{

	static char *sync_error_mesg = "Generated code for korient is out of sync with arguments specified in korient's *.pane file; please rerun ghostwriter on korient.";


	/*
	 * allocate the korient structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((unsigned)1, (unsigned) sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ww",
			  &(clui_info->ww_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "wh",
			  &(clui_info->wh_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "we",
			  &(clui_info->we_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "wd",
			  &(clui_info->wd_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "wt",
			  &(clui_info->wt_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "hw",
			  &(clui_info->hw_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "hh",
			  &(clui_info->hh_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "he",
			  &(clui_info->he_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "hd",
			  &(clui_info->hd_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ht",
			  &(clui_info->ht_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ew",
			  &(clui_info->ew_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "eh",
			  &(clui_info->eh_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ee",
			  &(clui_info->ee_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ed",
			  &(clui_info->ed_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "et",
			  &(clui_info->et_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "dw",
			  &(clui_info->dw_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "dh",
			  &(clui_info->dh_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "de",
			  &(clui_info->de_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "dd",
			  &(clui_info->dd_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "dt",
			  &(clui_info->dt_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "tw",
			  &(clui_info->tw_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "th",
			  &(clui_info->th_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "te",
			  &(clui_info->te_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "td",
			  &(clui_info->td_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "tt",
			  &(clui_info->tt_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



