 /*
  * Khoros: $Id$
  */

 /*
  * $Log$
  */

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private declarations for the color printmapval
   >>>>		       widget.
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Aug 05, 1992 15:05
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_PrintMapValP_h_
#define _xvisual_PrintMapValP_h_


    /*-------------------------------------*
    |       #include 
    ---------------------------------------*/

#include <xvisual/ColorP.h>
#include <xvisual/PrintMapVal.h>

    /*-------------------------------------*
    |       typedefs
    ---------------------------------------*/

typedef struct _XvwPrintMapValWidgetClass
{
    XtPointer extension;
} XvwPrintMapValWidgetClassPart;


typedef struct _XvwPrintMapValWidgetClassRec
{
    CoreClassPart		 core_class;
    CompositeClassPart		 composite_class;
    ConstraintClassPart		 constraint_class;
    XvwManagerWidgetClassPart	 manager_class;
    XvwGraphicsWidgetClassPart	 graphics_class;
    XvwColorWidgetClassPart	 color_class;
    XvwPrintMapValWidgetClassPart printmapval_class;
} XvwPrintMapValWidgetClassRec;


typedef struct
{
    /*  resources  */
    int     width;
    int     height;
    int     xposition;
    int     yposition;
    Boolean editable;
    Boolean showcolor;
    kobject object;
    int     update_mode;
    int     policy;

    Pixel    black;
    Pixel    white;
    int	     font_width;
    int	     font_height;

} XvwPrintMapValPart;


typedef struct _XvwPrintMapValWidgetRec
{
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    XvwManagerPart	manager;
    XvwGraphicsPart	graphics;
    XvwColorPart	color;
    XvwPrintMapValPart	printmapval;
} XvwPrintMapValWidgetRec;


typedef struct  _XvwPrintMapValWidgetClassRec  *XvwPrintMapValWidgetClass;
typedef struct  _XvwPrintMapValWidgetRec       *XvwPrintMapValWidget;


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwPrintMapValWidget
 */
extern  XvwPrintMapValWidgetClassRec xvwPrintMapValWidgetClassRec;


#endif /* _xvisual_PrintMapValP_h_ */
/* Don't add after this point */
